<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
      <!--
        <a-col :span="24">
          <a-form-item label="应急事件" v-bind="validateInfos.eventId">
	          <a-input-number v-model:value="formData.eventId" placeholder="请输入应急事件" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="处置步骤ID" v-bind="validateInfos.methodId">
	          <a-input-number v-model:value="formData.methodId" placeholder="请输入处置步骤ID" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        
        <a-col :span="24">
          <a-form-item label="处置时间" v-bind="validateInfos.handleTime">
		        <a-date-picker placeholder="请选择处置时间" v-model:value="formData.handleTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="处置人" v-bind="validateInfos.handleBy">
            <a-input v-model:value="formData.handleBy" placeholder="请输入处置人" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        -->
        <a-col :span="24">
          <a-form-item label="执行情况" v-bind="validateInfos.handleSta">
          <a-radio-group v-model:value="formData.handleSta"  :options="[{ label: '正常', value: '正常' },{ label: '异常', value: '异常' }]" />
	        </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="执行情况说明" v-bind="validateInfos.handleDes">
            <a-textarea v-model:value="formData.handleDes" placeholder="请输入执行情况说明" :disabled="disabled"></a-textarea>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../BcsHandleRecord.api';
  import { Form } from 'ant-design-vue';
  
  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    eventId: undefined,
    methodId: undefined,
    handleDes: '',   
    handleTime: '',   
    handleBy: '',   
    handleSta: undefined,
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });

  const qkvalue = ref<number>(1);

  
  /**
   * 新增
   */
  function add(record) {
    //edit({});
    formData.eventId=record.eventId;
    formData.methodId=record.id;
    console.log("record.eventId",record.eventId);
    console.log("record.id",record.id);
    
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 24px 24px 24px 24px;
  }
</style>
